#include <iostream>
#include <stdlib.h>
#include <time.h>
#include <string>
using namespace std;

class Person
{
public:
  virtual void print()
  {
    cout << "Person::print" << endl;
  }
  friend ostream& operator<<(ostream& os, const Person& p);
};
ostream& operator<<(ostream& os, const Person& p)
{
  cout << "operator<<(ostream& os, const Person& p)" << endl;
  return os;
}

class Employee : public Person
{
public:
  void print()
  {
    cout << "Employee::print" << endl;
  }
  friend ostream& operator<<(ostream& os, const Employee& p);
};
ostream& operator<<(ostream& os, const Employee& e)
{
  cout << "operator<<(ostream& os, const Employee& e)" << endl;
  const Person* ptr = &e; //upcast
  os << *ptr;
  return os;
}
class Manager : public Employee
{
public:
  void print()
  {
    cout << "Manager::print" << endl;
  }
  friend ostream& operator<<(ostream& os, const Manager& m);
};

ostream& operator<<(ostream& os, const Manager& m)
{
  cout << "operator<<(ostream& os, const Manager& m)" << endl;
  const Employee* ptr = &m;
  os << *ptr;
  return os;
}
int main()
{
  Person * p1;
  srand(time(NULL));
  int val = rand() % 2;
  if (val == 0)
    {
      p1 = new Manager;
    }
  else
    {
      p1 = new Person;
    }
  cout << "val = " << val << endl;
  p1 -> print();
  cout << (*p1) << endl;
  delete p1;
  return 0;
}
